View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.filter.codec.statemachine;
    21
    22  import org.apache.mina.core.buffer.IoBuffer;
    23  import org.apache.mina.filter.codec.ProtocolDecoderException;
    24  import org.apache.mina.filter.codec.ProtocolDecoderOutput;
    25
    26  /**
    27   * {@link DecodingState} which decodes <code>byte</code> values.
    28   *
    29   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    30   */
    31  public abstract class SingleByteDecodingState implements DecodingState {
    32
    33      public DecodingState decode(IoBuffer in, ProtocolDecoderOutput out) throws Exception {
    34          if (in.hasRemaining()) {
    35              return finishDecode(in.get(), out);
    36          }
    37
    38          return this;
    39      }
    40
    41      /**
    42       * {@inheritDoc}
    43       */
    44      public DecodingState finishDecode(ProtocolDecoderOutput out) throws Exception {
    45          throw new ProtocolDecoderException("Unexpected end of session while waiting for a single byte.");
    46      }
    47
    48      /**
    49       * Invoked when this state has consumed a complete <code>byte</code>.
    50       *
    51       * @param b the byte.
    52       * @param out the current {@link ProtocolDecoderOutput} used to write
    53       *        decoded messages.
    54       * @return the next state if a state transition was triggered (use
    55       *         <code>this</code> for loop transitions) or <code>null</code> if
    56       *         the state machine has reached its end.
    57       * @throws Exception if the read data violated protocol specification.
    58       */
    59      protected abstract DecodingState finishDecode(byte b, ProtocolDecoderOutput out) throws Exception;
    60  }